// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/GPSDetails.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'GPS_FIX_STATE_NO_FIX'.
/**
  * GPS position has not been fixed.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_NO_FIX = 0
};

/// Constant 'GPS_FIX_STATE_DEAD_RECKONING_ONLY'.
/**
  * GPS position is dead reckoned only.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_DEAD_RECKONING_ONLY = 1
};

/// Constant 'GPS_FIX_STATE_2D_FIX'.
/**
  * The horizontal position with latitude/longitude (or northing/easting or X/Y) is fixed.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_2D_FIX = 2
};

/// Constant 'GPS_FIX_STATE_3D_FIX'.
/**
  * The horizontal and vertical position with latitude/longitude/altitude (northing/easting/altitude or X/Y/Z) is fixed.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_3D_FIX = 3
};

/// Constant 'GPS_FIX_STATE_GPS_PLUS_DEAD_RECKONING'.
/**
  * Position is calculated by GPS and combined with dead reckoning.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_GPS_PLUS_DEAD_RECKONING = 4
};

/// Constant 'GPS_FIX_STATE_TIME_ONLY_FIX'.
/**
  * Only time is fixed.
 */
enum
{
  psdk_interfaces__msg__GPSDetails__GPS_FIX_STATE_TIME_ONLY_FIX = 5
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/GPSDetails in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__GPSDetails
{
  std_msgs__msg__Header header;
  /// Horizontal dilution of precision, unit: 0.01, eg: 100 = 1.00, <1: ideal, 1-2: excellent, 2-5: good, 5-10: moderate, 10-20: fair, >20: poor.
  float horizontal_dop;
  /// Position dilution of precision, unit: 0.01, eg: 100 = 1.00, <1: ideal, 1-2: excellent, 2-5: good, 5-10: moderate, 10-20: fair, >20: poor.
  float position_dop;
  float fix_state;
  /// Vertical position accuracy (mm), the smaller, the better.
  float vertical_accuracy;
  /// Horizontal position accuracy (mm), the smaller, the better.
  float horizontal_accuracy;
  /// Speed accuracy (cm/s), the smaller, the better.
  float speed_accuracy;
  /// Number of GPS satellites used for fixing position.
  uint32_t num_gps_satellites_used;
  /// Number of GLONASS satellites used for fixing position.
  uint32_t num_glonass_satellites_used;
  /// Total number of satellites used for fixing position.
  uint16_t num_total_satellites_used;
  /// Accumulated times of sending GPS data.
  uint16_t gps_counter;
} psdk_interfaces__msg__GPSDetails;

// Struct for a sequence of psdk_interfaces__msg__GPSDetails.
typedef struct psdk_interfaces__msg__GPSDetails__Sequence
{
  psdk_interfaces__msg__GPSDetails * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__GPSDetails__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_H_
